<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SpaceFighter2020: src/Player.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SpaceFighter2020
   </div>
   <div id="projectbrief">This documentation reffers to the game Space Fighter 2020 created for pa2 course. Game is side-scrolling shooter where the goal is to get on the end of the level and kill as much as enemy ships as possible. Player can pick up bonuses for repairing point of health or upgrading his weapons.</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">Player.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="Player_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef Player_H</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define Player_H</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160; </div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">//#include &quot;GameObject.h&quot;</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="Entity_8h.html">Entity.h</a>&quot;</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160; </div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">//#include &quot;Bonus.h&quot;</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="keyword">class </span><a class="code" href="classCollisionVisitor.html">CollisionVisitor</a>;</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160; </div>
<div class="line"><a name="l00014"></a><span class="lineno"><a class="line" href="classPlayer.html">   14</a></span>&#160;<span class="keyword">class </span><a class="code" href="classPlayer.html">Player</a> : <span class="keyword">public</span> <a class="code" href="classEntity.html">Entity</a>{</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;    <a class="code" href="classPlayer.html#affe0cc3cb714f6deb4e62f0c0d3f1fd8">Player</a>();</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classPlayer.html#a05b60cac1922c5be5c1be16baffa4497">Update</a>();</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classPlayer.html#adb5aed7b84adc4628817d6da2cecc2e1">KeyPressed</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> &amp; key);</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    </div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classPlayer.html#ab875e8cc8856544fdff9759cd5576266">Damage</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> &amp; dmg)<span class="keyword">override</span>;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160; </div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classPlayer.html#a97b7e9bf5975684133e4ec7e939ab23f">GetWeaponLevel</a>()<span class="keyword">const</span>;</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classPlayer.html#a113c9d126fc5c8207f9022c758204966">Visit</a> (<a class="code" href="classCollisionVisitor.html">CollisionVisitor</a> * visitor) <span class="keyword">override</span>;</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classPlayer.html#ab417c6af3306a28ba9d0a047be5dd580">CollideWith</a> (<a class="code" href="classGameObject.html">GameObject</a> * collisionObject) <span class="keyword">override</span>;</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classPlayer.html#aef35ce5aa7fffc4109b22a55a10018d4">Heal</a>();</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160; </div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classPlayer.html#aafc1cccd4d693d203b713573c16ac964">UpgradeRocket</a>();</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160; </div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classPlayer.html#a3413569d8f44c258e17de759916f4734">UpgradeMachineGun</a>();</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    </div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classPlayer.html#a11620bd1b75a51561cead553e04c1247">UpgradeCanon</a>();</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    </div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classPlayer.html#aec557c30fd3a978e4a44d1aad9e033fc">InitWeapon</a>()<span class="keyword">override</span>;</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classPlayer.html#a4c3cae84a7c20d37295b4dacca62c553">SetupStats</a>()<span class="keyword">override</span>;</div>
<div class="line"><a name="l00061"></a><span class="lineno"><a class="line" href="classPlayer.html#a2644b9d7454cc83c1aedfda10f48dfca">   61</a></span>&#160;    std::chrono::time_point&lt;std::chrono::system_clock&gt; <a class="code" href="classPlayer.html#a2644b9d7454cc83c1aedfda10f48dfca">m_Clock</a>;</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;};</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160; </div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* Player_H */</span><span class="preprocessor"></span></div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclassGameObject_html"><div class="ttname"><a href="classGameObject.html">GameObject</a></div><div class="ttdoc">Abstract class that represents GameObject with collision and movement properties.</div><div class="ttdef"><b>Definition:</b> GameObject.h:14</div></div>
<div class="ttc" id="aclassPlayer_html_a113c9d126fc5c8207f9022c758204966"><div class="ttname"><a href="classPlayer.html#a113c9d126fc5c8207f9022c758204966">Player::Visit</a></div><div class="ttdeci">void Visit(CollisionVisitor *visitor) override</div><div class="ttdoc">Pure virtual function for accepting visitor.</div><div class="ttdef"><b>Definition:</b> Player.cpp:71</div></div>
<div class="ttc" id="aclassPlayer_html_aafc1cccd4d693d203b713573c16ac964"><div class="ttname"><a href="classPlayer.html#aafc1cccd4d693d203b713573c16ac964">Player::UpgradeRocket</a></div><div class="ttdeci">void UpgradeRocket()</div><div class="ttdoc">Rocket luncher upgrade modifier.</div><div class="ttdef"><b>Definition:</b> Player.cpp:86</div></div>
<div class="ttc" id="aclassPlayer_html_a3413569d8f44c258e17de759916f4734"><div class="ttname"><a href="classPlayer.html#a3413569d8f44c258e17de759916f4734">Player::UpgradeMachineGun</a></div><div class="ttdeci">void UpgradeMachineGun()</div><div class="ttdoc">Machine gun upgrade modifier.</div><div class="ttdef"><b>Definition:</b> Player.cpp:97</div></div>
<div class="ttc" id="aEntity_8h_html"><div class="ttname"><a href="Entity_8h.html">Entity.h</a></div></div>
<div class="ttc" id="aclassPlayer_html_a2644b9d7454cc83c1aedfda10f48dfca"><div class="ttname"><a href="classPlayer.html#a2644b9d7454cc83c1aedfda10f48dfca">Player::m_Clock</a></div><div class="ttdeci">std::chrono::time_point&lt; std::chrono::system_clock &gt; m_Clock</div><div class="ttdef"><b>Definition:</b> Player.h:61</div></div>
<div class="ttc" id="aclassPlayer_html_ab875e8cc8856544fdff9759cd5576266"><div class="ttname"><a href="classPlayer.html#ab875e8cc8856544fdff9759cd5576266">Player::Damage</a></div><div class="ttdeci">void Damage(const int &amp;dmg) override</div><div class="ttdoc">Deals damage to player and if ends game if health reaches zero. Can be damaged only once per set dura...</div><div class="ttdef"><b>Definition:</b> Player.cpp:50</div></div>
<div class="ttc" id="aclassPlayer_html_a11620bd1b75a51561cead553e04c1247"><div class="ttname"><a href="classPlayer.html#a11620bd1b75a51561cead553e04c1247">Player::UpgradeCanon</a></div><div class="ttdeci">void UpgradeCanon()</div><div class="ttdoc">Cannon upgrade modifier.</div><div class="ttdef"><b>Definition:</b> Player.cpp:107</div></div>
<div class="ttc" id="aclassPlayer_html_a97b7e9bf5975684133e4ec7e939ab23f"><div class="ttname"><a href="classPlayer.html#a97b7e9bf5975684133e4ec7e939ab23f">Player::GetWeaponLevel</a></div><div class="ttdeci">int GetWeaponLevel() const</div><div class="ttdef"><b>Definition:</b> Player.cpp:67</div></div>
<div class="ttc" id="aclassPlayer_html_aef35ce5aa7fffc4109b22a55a10018d4"><div class="ttname"><a href="classPlayer.html#aef35ce5aa7fffc4109b22a55a10018d4">Player::Heal</a></div><div class="ttdeci">void Heal()</div><div class="ttdoc">Heal bonus modifier.</div><div class="ttdef"><b>Definition:</b> Player.cpp:80</div></div>
<div class="ttc" id="aclassPlayer_html_a4c3cae84a7c20d37295b4dacca62c553"><div class="ttname"><a href="classPlayer.html#a4c3cae84a7c20d37295b4dacca62c553">Player::SetupStats</a></div><div class="ttdeci">void SetupStats() override</div><div class="ttdoc">Pure virtual function for setring up variables.</div><div class="ttdef"><b>Definition:</b> Player.cpp:23</div></div>
<div class="ttc" id="aclassEntity_html"><div class="ttname"><a href="classEntity.html">Entity</a></div><div class="ttdoc">Abstract class representing GameObjects that have weapon and health.</div><div class="ttdef"><b>Definition:</b> Entity.h:10</div></div>
<div class="ttc" id="aclassPlayer_html_affe0cc3cb714f6deb4e62f0c0d3f1fd8"><div class="ttname"><a href="classPlayer.html#affe0cc3cb714f6deb4e62f0c0d3f1fd8">Player::Player</a></div><div class="ttdeci">Player()</div><div class="ttdef"><b>Definition:</b> Player.cpp:6</div></div>
<div class="ttc" id="aclassPlayer_html_adb5aed7b84adc4628817d6da2cecc2e1"><div class="ttname"><a href="classPlayer.html#adb5aed7b84adc4628817d6da2cecc2e1">Player::KeyPressed</a></div><div class="ttdeci">void KeyPressed(const int &amp;key)</div><div class="ttdoc">Handles key input for movement.</div><div class="ttdef"><b>Definition:</b> Player.cpp:41</div></div>
<div class="ttc" id="aclassPlayer_html_a05b60cac1922c5be5c1be16baffa4497"><div class="ttname"><a href="classPlayer.html#a05b60cac1922c5be5c1be16baffa4497">Player::Update</a></div><div class="ttdeci">void Update()</div><div class="ttdoc">Pure virtual Update function that is used in GameScene's game loop.</div><div class="ttdef"><b>Definition:</b> Player.cpp:12</div></div>
<div class="ttc" id="aclassPlayer_html"><div class="ttname"><a href="classPlayer.html">Player</a></div><div class="ttdoc">Represent player, takes user input.</div><div class="ttdef"><b>Definition:</b> Player.h:14</div></div>
<div class="ttc" id="aclassPlayer_html_aec557c30fd3a978e4a44d1aad9e033fc"><div class="ttname"><a href="classPlayer.html#aec557c30fd3a978e4a44d1aad9e033fc">Player::InitWeapon</a></div><div class="ttdeci">void InitWeapon() override</div><div class="ttdoc">Pure virtual function for initializing weapon.</div><div class="ttdef"><b>Definition:</b> Player.cpp:36</div></div>
<div class="ttc" id="aclassCollisionVisitor_html"><div class="ttname"><a href="classCollisionVisitor.html">CollisionVisitor</a></div><div class="ttdoc">Abstract class of double dispatch visitor design patter.</div><div class="ttdef"><b>Definition:</b> CollisionVisitor.h:18</div></div>
<div class="ttc" id="aclassPlayer_html_ab417c6af3306a28ba9d0a047be5dd580"><div class="ttname"><a href="classPlayer.html#ab417c6af3306a28ba9d0a047be5dd580">Player::CollideWith</a></div><div class="ttdeci">void CollideWith(GameObject *collisionObject) override</div><div class="ttdoc">Creates Visitor object and passes collisionObject parameter.</div><div class="ttdef"><b>Definition:</b> Player.cpp:75</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
